#
#     Sam Hadow - Huffman-py
#     Copyright (C) 2023
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import *
class InputDialog(QDialog):
    def __init__(self, texte1, texte2, thirdBox = False, texte3=None, parent=None):
        super().__init__(parent)

        self.setWindowTitle("données")

        self.box1 = QLineEdit(self)
        self.box2 = QLineEdit(self)
        buttonBox = QDialogButtonBox(QDialogButtonBox.Ok | QDialogButtonBox.Cancel, self);

        layout = QFormLayout(self)
        layout.addRow(texte1, self.box1)
        layout.addRow(texte2, self.box2)

        self.thirdBox = thirdBox
        if self.thirdBox:
            self.box3 = QLineEdit(self)
            layout.addRow(texte3, self.box3)

        layout.addWidget(buttonBox)

        buttonBox.accepted.connect(self.accept)
        buttonBox.rejected.connect(self.reject)

    def getInputs(self):
        if self.thirdBox:
            return (self.box1.text(), self.box2.text(), self.box3.text())
        else:
            return (self.box1.text(), self.box2.text())
